#include <iostream>
#include<string>
#include <tuple>

using namespace std;

template<int N, typename T1, typename...dal>
struct vbr_typu
{
	typedef typename vbr_typu<N - 1, dal...>::typ typ;
};

template<typename T1, typename...dal>
struct vbr_typu<0, T1, dal...>
{
	typedef T1 typ;
};

template<int N, typename...dal>
using vbr_typu_t = typename vbr_typu<N, dal...>::typ;

template<typename HLAVA, typename...OHON>
class entice
	: private entice<OHON...>
{
	using Ohon = entice<OHON...>;
public:
	entice() {};
	entice(HLAVA hlava, OHON ... ohon)
		: hlava(hlava), Ohon(ohon...) {}
	HLAVA& data()
	{
		return hlava;
	}
	entice<OHON...>* bze()
	{
		return static_cast<Ohon*>(this);
	}
protected:
	HLAVA hlava;
};

template<typename HLAVA>
class entice<HLAVA>
{
public:
	entice() {}
	entice(HLAVA hlava) : hlava(hlava) {}
	HLAVA& data()
	{
		return hlava;
	}
	entice* bze() { return this; }
protected:
	HLAVA hlava;
};

template<typename VSLEDEK, int N>
struct najdi
{
	template<typename T>
	static VSLEDEK& data(T& t)
	{
		return najdi<VSLEDEK, N - 1>::data(*t.bze());
	}
};

template<typename VSLEDEK>
struct najdi<VSLEDEK, 0>
{
	template<typename T>
	static VSLEDEK& data(T& t)
	{
		return t.data();
	}
};

template<int K, typename...T>
vbr_typu_t<K, T...>& data(entice<T...>& t)
{
	return najdi<vbr_typu_t<K, T...>, K>::data(t);
}



// tisk na n-tice 
template<class Entice, std::size_t ... Is>
void tisk_entice_impl(std::ostream& proud, const Entice& en, std::index_sequence<Is...>)
{
	((proud << (Is == 0 ? "" : ", ") << data<Is>((Entice&)en)), ...);
}

template<class... Param>
auto& operator<<(std::ostream& proud, const entice<Param...>& en)
{
	proud << "{";
	tisk_entice_impl(proud, en, std::index_sequence_for<Param...>{});
	return proud << "}";
}

//--------------------------------------------------
// tisk n-tice (std::tuple)
template<class Znak, class Rysy, class Tuple, std::size_t... Is>
void tisk_tuple_impl(std::basic_ostream<Znak, Rysy>& proud,
	const Tuple& t,
	std::index_sequence<Is...>)
{
	((proud << (Is == 0 ? "" : ", ") << std::get<Is>(t)), ...);
}

template<class Znak, class Rysy, class... Args>
auto& operator<<(std::basic_ostream<Znak, Rysy>& proud,
	const std::tuple<Args...>& t)
{
	proud << "(";
	tisk_tuple_impl(proud, t, std::index_sequence_for<Args...>{});
	return proud << ")";
}
//--------------------------------------------------

// Pomocn funkce pro vytvoen entice
template<class ... Param>
entice<Param...> vytvo_entici(Param ... param)
{
	return entice<Param...>(param...);
}

int main()
{

	entice<double, int, long> en(6.0, 8, 9L);
	auto en1 = vytvo_entici(6.0, 8, 9L);
	//tisk_entice_impl(cout, en, make_index_sequence<3>{});
	cout << en;
	cout << en.data() << endl;
	vbr_typu<2, int, long, double>::typ x = 0;
	auto yyy = data<2>(en);
	//cout << en;
	auto z = make_tuple(1, "ahoj"s, 9.2);
	cout << z << endl;
}